package cn.iocoder.yudao.module.shop.mapper;

import cn.iocoder.yudao.module.shop.entity.UserBalance;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 用户积分Mapper接口
 *
 * @author ruoyi
 * @date 2023-07-09
 */
@Mapper
public interface UserBalanceMapper extends BaseMapper<UserBalance>
{
    /**
     * 查询用户积分
     *
     * @param id 用户积分主键
     * @return 用户积分
     */
    public UserBalance selectShopUserBalanceById(Long id);

    /**
     * 查询用户积分列表
     *
     * @param shopUserBalance 用户积分
     * @return 用户积分集合
     */
    public List<UserBalance> selectShopUserBalanceList(UserBalance shopUserBalance);

    /**
     * 新增用户积分
     *
     * @param shopUserBalance 用户积分
     * @return 结果
     */
    public int insertShopUserBalance(UserBalance shopUserBalance);

    /**
     * 修改用户积分
     *
     * @param shopUserBalance 用户积分
     * @return 结果
     */
    public int updateShopUserBalance(UserBalance shopUserBalance);

    /**
     * 删除用户积分
     *
     * @param id 用户积分主键
     * @return 结果
     */
    public int deleteShopUserBalanceById(Long id);

    /**
     * 批量删除用户积分
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteShopUserBalanceByIds(Long[] ids);

    public UserBalance selectShopUserBalanceByUserId(Long userId);
    //冻结积分
    void frozenBalance(@Param("frozenBalance") Long balance,@Param("userId") Long userId);
    //解冻积分
    void thawBalance(@Param("frozenBalance") Long balance,@Param("userId") Long userId);
    //核销积分
    void subtractFrozenBalance(@Param("frozenBalance") Long balance,@Param("userId") Long userId);
    //核销积分
    void subtractBalance(@Param("balance") Long balance,@Param("userId") Long userId);

    //核销积分
    void addBalance(@Param("balance") Long balance,@Param("userId") Long userId);
    //奖励积分
    void rewardBalance(@Param("balance") Long balance,@Param("userId") Long userId);
    //退款积分
    void refundBalance(@Param("balance") Long balance,@Param("userId") Long userId);

}
